
<template>
    <v-card tile flat elevation-0>
        <v-card-text>
            <v-container grid-list-md dense>
                <v-layout wrap>
                    <v-flex xs12 class="subheading" style="color: #2196F3">
                        <v-icon color="primary">assignment</v-icon> {{ $i18n.t("application.form.generalInformation") }}
                    </v-flex>
                    <v-flex xs12>
                        <v-text-field 
                            browser-autocomplete='off'  
                            name="title"
                            autofocus
                            :placeholder="$i18n.t('application.form.position') + '*'"
                            @change="$emit('change')"
                            :rules="validationRules.position"
                            v-model="application.title" />
                    </v-flex>
                    <v-flex xs12 sm6>
                       <v-autocomplete
                            clearable
                            :placeholder="$i18n.t('application.form.company') + '*'" 
                            browser-autocomplete='off' 
                            item-text="name"
                            item-avatar="logo"
                            return-object
                            @change="$emit('change')"
                            v-model="application.company"
                            :rules="validationRules.company"
                            :items="companies"
                            :loading="isLoading"
                            :search-input.sync="search">
                            
                            <template slot="selection" slot-scope="{ item }">
                                <div style="overflow-x: hidden; white-space: nowrap; ">
                                  <img v-if="item && item.logo" :src="item.logo" class="company-logo" style="vertical-align: middle;">
                                  <span v-if="item && item.name" v-text="item.name" ></span>
                                </div>
                            </template>
                            
                            <template slot="item" slot-scope="{ item }">
                                <v-list-tile-avatar class="headline">
                                  <img v-if="item && item.logo" :src="item.logo" style="margin-top: 24px; height: 20px; width: 20px;" />
                                </v-list-tile-avatar>
                                <v-list-tile-content>
                                  <v-list-tile-title v-if="item && item.name" v-text="item.name"></v-list-tile-title>
                                </v-list-tile-content>
                              </template>
                       </v-autocomplete>
                    </v-flex>
                    <v-flex xs12 sm6>
                         <v-select 
                            :disabled="mode=='edit'"  
                            :items="statuses" 
                            @change="$emit('change')"
                            v-model="application.status" 
                            :placeholder="$i18n.t('application.form.status')"
                            item-text="text"
                            item-value="value"></v-select>
                    </v-flex>
                    
                    <v-flex xs12 sm8>
                        <v-text-field 
                            browser-autocomplete='off'  
                            name="listingUrl" 
                            @change="$emit('change')"
                            :placeholder="$i18n.t('application.form.listingUrl') + ', e.g. https://indeed.com/viewjob?jk=<job-id>'" 
                            v-model="application.listingUrl"></v-text-field>
                    </v-flex>
                    <v-flex xs12 sm4>
                        <v-text-field browser-autocomplete='off' name="location" :label="$i18n.t('application.form.location')" v-model="application.location"></v-text-field>
                    </v-flex>
                    
                    <v-flex xs12 class="subheading mt-2" style="color: #2196F3">
                        <v-icon color="primary">account_box</v-icon> {{ $i18n.t("application.form.contactInformation") }}
                    </v-flex>
                    <v-flex xs12 sm6>
                        <v-text-field 
                            browser-autocomplete='off' 
                            @change="$emit('change')"
                            name="firstName" 
                            :placeholder="$i18n.t('application.form.contact.firstName')" 
                            v-model="application.contact.firstName"></v-text-field>
                    </v-flex>
                    <v-flex xs12 sm6>
                        <v-text-field 
                            browser-autocomplete='off' 
                            @change="$emit('change')"
                            name="lastName" 
                            :placeholder="$i18n.t('application.form.contact.lastName')" 
                            v-model="application.contact.lastName"></v-text-field>
                    </v-flex>
                    
                    <v-flex xs12 sm6>
                        <v-text-field 
                            :rules="validationRules.email" 
                            browser-autocomplete='off' 
                            @change="$emit('change')"
                            name="email" 
                            :placeholder="$i18n.t('application.form.contact.email')"
                            v-model="application.contact.email"></v-text-field>
                    </v-flex>
                    <v-flex xs12 sm6>
                        <v-text-field browser-autocomplete='off'  name="phone" :placeholder="$i18n.t('application.form.contact.phone')" v-model="application.contact.phone"></v-text-field>
                    </v-flex>
                    
                    <v-flex xs12 class="subheading mt-2" style="color: #2196F3" colro="primary">
                        <v-icon color="primary">edit</v-icon> {{ $i18n.t("application.form.note") }}
                    </v-flex>
                    <v-flex xs12>
                         <v-textarea 
                                browser-autocomplete='off' 
                                @change="$emit('change')"
                                auto-grow :no-resize="false" 
                                :label="$i18n.t('application.form.description')" 
                                name="description" 
                                rows="3" 
                                v-model="application.description"/>
                    </v-flex>
                </v-layout>
            </v-container>
        </v-card-text>
    </v-card>
</template>

<script>
import axios from 'axios'
export default {
  name: 'ApplicationForm',
  props: ['application', 'mode'],
  data() {
    return {
      entries: [],
      isLoading: false,
      search: null
    }
  },
  methods: {
    name(item) {
      const name = item && item.name ? item.name : ""
      return name.length > 15 ? `${name.substring(0, 12)}...` : name
    }
  },
  computed: {
      validationRules() {
        return  {
            position: [v => !!v || this.$i18n.t("application.form.validation.position")],
            email: [v => !v || /^.+@[^.].*\.[a-z]{2,6}$/.test(v) || this.$i18n.t("application.form.validation.email")],
            phoneNumber: [v => !v || /^\+(?:[0-9] ?){6,14}[0-9]$/.test(v) || this.$i18n.t("application.form.validation.phone")],
            company: [v => (!!v && !!v.name) || this.$i18n.t("application.form.validation.company")]
          }
      },
      statuses() {
        return  [
            { text: this.$i18n.t("application.status.saved"), value: 'SAVED' },
            { text: this.$i18n.t("application.status.applied"), value: 'APPLIED' },
            { text: this.$i18n.t("application.status.in_progress"), value: 'IN_PROGRESS' }
          ]
      },
      companies () {
        if ( this.entries.length == 0 ) {
            return [this.application.company]
        }
        return this.entries;
      }
  },
  watch: {
      async search (val) {
        //companies have already been loaded
        if (!val || val.length < 3 || val == this.lastSearch) return
    
        this.lastSearch = val

        //companies have already been requested
        if (this.isLoading) return

        this.isLoading = true

        try {
            const response = await axios.get(`https://autocomplete.clearbit.com/v1/companies/suggest?query=${val}`);
            this.entries = response.data
            this.count = this.entries.length
        }
        catch ( e ) {
            this.$logger.error(e.message)
        }

        this.isLoading = false
      }
  }
}
</script>